#!/usr/bin/env python3
# coding: UTF-8

import os
import sys

def getch():
	if os.name == 'nt':
		import msvcrt
		return msvcrt.getch().decode('utf-8')
	elif os.name == 'posix':
		import tty, termios
		fd = sys.stdin.fileno()
		old_settings = termios.tcgetattr(fd)

		try:
			tty.setraw(sys.stdin.fileno())
			ch = sys.stdin.read(1)
		finally:
			termios.tcsetattr(fd, termios.TCSADRAIN, old_settings)
		return ch
	return None

if __name__ == '__main__':
	while True:
		try:
			c = getch()
		except KeyboardInterrupt:
			break

		print(c)
		if c == 'q':
			break
